/*****************************************************
 cw 

Project : CW    
Version : 1.04
Date    : 28.01.2014
Author  : Toni                            
Company : rtk                             
Comments: 
		      
		27  -     
		26  -   .   PC0, 23 
		25  -  -   
		24  -  -   
		  -   , ,   "/"


Chip type           : ATmega8A
Program type        : Application
Clock frequency     : 2,0 MHz
*****************************************************/


#define F_CPU 2000000L
#define baudrate 9600
#define bauddivider F_CPU/16/baudrate-1
#define KNOB_SET_PARAM 5 //    
#define KNOB_ADC_PC0 4  //    ,   ->   PC0,  ADC7   TQFP
#define KNOB_TEMP_OFF 3 //   ,       
#define KNOB_U_OFF 2 //   ,       
#define MAX_LENGTH_STR 60  //   
#define CARRIAGE_RETURN 13  // ascii  
#define led 0
#define cw 0  //  cw
#define SPEED 1  //    
#define TIRE 300*SPEED
#define TOCHKA 100*SPEED
#define SYMB_PAUSE 300*SPEED
#define WORD_PAUSE 600*SPEED
#define R_division 2  //     
#define BEEP_PAUSE_ 4000 //            
#define PERIOD_BEEP_ 25 //25      = (BEEP_PAUSE/1000)*PERIOD_BEEP  
#define BUS   OWI_PIN_1   //     ,     OWIPolled.h
#define LETTER_BEEP_ 'S'
#define U_POROG 3050   //            
#define USER_TXT 1 //               
#define USER_PERIOD_BEEP 2
#define USER_BEEP_PAUSE 3
#define USER_LETTER_BEEP 4
#define USER_BEEPER_ENABLE 5  //    0 , 1 
#define USER_VOLTMETER_ENABLE 6 //    0 , 1 
#define USER_TEMP_ENABLE 7 //       0 , 1 
#define DELAY_BEEPER_DISABLE 20000 //     20 
#define MAX_POROG_BEEP_PAUSE 60   //       
#define MIN_POROG_BEEP_PAUSE 2	//       
#define MIN_POROG_PERIOD_DBEEP 1    //       
#define MAX_POROG_PERIOD_DBEEP 100  //       
//  DS18B20
#define DS18B20_CONVERT_T                0x44
#define DS18B20_READ_SCRATCHPAD          0xbe 

#include <avr/io.h>
#include <avr/iom8.h>
//#include <avr/wdt.h>
#include <stdint.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <avr/sleep.h>
//#include <math.h>

//      1-wire 
#include "OWIPolled.h"
#include "OWIHighLevelFunctions.h"
#include "OWIBitFunctions.h"
#include "common_files/OWIcrc.h"
#include "common_files/OWIdefs.h"

typedef void func_type (void);
//  

struct 
	{
	unsigned char low_voltage:1;  //         
	unsigned char beeper_enable:1; //     0 , 1 
	unsigned char voltmeter_enable:1; //    0 , 1 
	unsigned char temp_enable:1; //       0 , 1 
	} flags;

unsigned char scratchpad[9];  //      
unsigned short count, beep_pause; //    
unsigned char period_beep, letter_beep[2]={"S"};
unsigned char *ptr, cw_str[MAX_LENGTH_STR]={" VVV BALLON BEACON"};   //     ,  
unsigned char cw_str_vbatt[11]={" VBATT XXX"};  //    
unsigned char cw_str_temp[10]={"TEMP XXXX"};  //    
unsigned char cw_str_end[5]={" KKK"};  //   
unsigned char cw_str_ok[4]=(" OK");
unsigned char cw_str_error[7]=(" ERROR");
unsigned char cw_str_settings[5]=(" SET");
void (*p)(void);  //   
float float_var;  //  
unsigned int adc;  //  
unsigned char ee_txt_url[59] EEMEM={"CW AVR beacon. V1.04.20142801 by Toni. http://r4n.su/forum"};
unsigned char ee_txt_hint[27] EEMEM={"Input text. 60 symb max: "}; //     
unsigned char ee_txt_hint_set[72] EEMEM={'T',' ','-',' ','S','e','t',' ','t','e','x','t',' ',CARRIAGE_RETURN,'P',' ','-',' ','N',' ','o','f',' ','b','e','e','p',' ',CARRIAGE_RETURN,'B',' ','-',' ','B','e','e','p',' ','p','a','u','s','e',' ',CARRIAGE_RETURN,'L',' ','-',' ','L','e','t','t','e','r',' ','b','e','e','p',' ',CARRIAGE_RETURN,'E',' ','-',' ','E','x','i','t',CARRIAGE_RETURN,0}; //     
unsigned char ee_cw_text[MAX_LENGTH_STR] EEMEM={" TEST STRING"};
unsigned char ee_txt_hint_period_beep[31] EEMEM={"Number of repeat beep (1-100):"};
unsigned char ee_txt_hint_beep_pause[19] EEMEM={"Beep pause (2-60):"};
unsigned char ee_txt_hint_set_letter[18] EEMEM={"Set letter (A-Z):"};
unsigned char ee_txt_voltmeter[15] EEMEM={"V - Voltmeter="};
unsigned char ee_txt_temp[17] EEMEM={"C - Temperature="};
unsigned char ee_txt_on[3] EEMEM={"ON"};
unsigned char ee_txt_off[4] EEMEM={"OFF"};
unsigned char ee_txt_set_pause_in_beep_pause[26] EEMEM={". Set pause in Beep pause"};
unsigned char ee_txt_beeper[12] EEMEM={"M - Beeper="};
unsigned char ee_period_beep EEMEM;
unsigned short ee_beep_pause EEMEM;
unsigned char ee_letter_beep[1] EEMEM;
unsigned char ee_flags EEMEM=0b11100000;   //   ,    ,  ,   

//---------------FUNCTIONS--------------------------

	void temp_measure(void)
		{
		unsigned int tmp = 0;
		unsigned char temperature;
		unsigned char i;
		OWI_Init(BUS);
		/*  
  		      
 		  - c  */
 		OWI_DetectPresence(BUS);
  		OWI_SkipRom(BUS);
  		OWI_SendByte(DS18B20_CONVERT_T ,BUS);
		/*,    */ 
		while (!OWI_ReadBit(BUS));
		/*  
    	      
   		 -   
		      */
		OWI_DetectPresence(BUS);
		OWI_SkipRom(BUS);
		OWI_SendByte(DS18B20_READ_SCRATCHPAD, BUS);
		scratchpad[0] = OWI_ReceiveByte(BUS);
		scratchpad[1] = OWI_ReceiveByte(BUS); 
		if ((scratchpad[1]&128) == 0) cw_str_temp[5]='P';
			else
				{
   				cw_str_temp[5]='M';
				tmp = ((unsigned int)scratchpad[1]<<8)|scratchpad[0];
				tmp = ~tmp + 1;
				scratchpad[0] = tmp;
				scratchpad[1] = tmp>>8;  
    			}
		//  .     
    	temperature = (scratchpad[0]>>4)|((scratchpad[1]&7)<<4);
		i=temperature/10;
		cw_str_temp[6]=0x30+i;
		i=temperature-i*10;
		cw_str_temp[7]=0x30+i;
		//   . 
		temperature = (scratchpad[0]&15);
		temperature = (temperature<<1) + (temperature<<3);
		temperature = (temperature>>4);
		cw_str_temp[8]=0x30+temperature;
		}

	void start_timer2(void)
		{
		TIMSK|=1<<TOIE2;  //     
		TCNT2=130; //  
		SFIOR|=1<<PSR2;  //  
		TCCR2|=1<<CS21; //     8
		}
	void stop_timer2(void)
		{
		TCCR2=0;
		TIMSK&=~(1<<TOIE2);
		}
//  
	void usart_init(unsigned int bauddiv)
		{
		UBRRH=(unsigned char)(bauddiv>>8);
		UBRRL=(unsigned char)(bauddiv);
	//	UCSRB|=1<<TXEN;
		UCSRB=(1<<TXEN)|(1<<RXEN); //    ,   
		UCSRC|=(1<<URSEL)|(1<<UCSZ1)|(1<<UCSZ0);   // 8  , 1  
		}
//  
	void usart_tx(unsigned char buff)
		{
		while ( !(UCSRA&(1<<UDRE)) );
		UDR=buff;
		}

	void cw_delay (unsigned short pause)   //      ,      SLEEP,     
		{
			sei();
			start_timer2();
			while(pause)
				{
				sleep_mode();
				pause--;
				}
			stop_timer2();
			cli();
		}


	void tochka(void)
		{
		PORTB|=1<<cw;
		cw_delay(TOCHKA);
		PORTB&=~(1<<cw);
		cw_delay(TOCHKA);
		}

	void tire(void)
		{
		PORTB|=1<<cw;
		cw_delay(TIRE);
		PORTB&=~(1<<cw);
		cw_delay(TOCHKA);
		}

	void bukvA(void)
		{
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvB(void)
		{
		tire();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvC(void)
		{
		tire();
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvD(void)
		{
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvE(void)
		{
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvF(void)
		{
		tochka();
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvG(void)
		{
		tire();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvH(void)
		{
		tochka();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvI(void)
		{
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvJ(void)
		{
		tochka();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvK(void)
		{
		tire();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvL(void)
		{
		tochka();
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvM(void)
		{
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvN(void)
		{
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvO(void)
		{
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvP(void)
		{
		tochka();
		tire();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvQ(void)
		{
		tire();
		tire();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvR(void)
		{
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvS(void)
		{
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvT(void)
		{
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvU(void)
		{
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}

	void bukvV(void)
		{
		tochka();
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvW(void)
		{
		tochka();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvX(void)
		{
		tire();
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvY(void)
		{
		tire();
		tochka();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvZ(void)
		{
		tire();
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif0(void)
		{
		tire();
		tire();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif1(void)
		{
		tochka();
		tire();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif2(void)
		{
		tochka();
		tochka();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif3(void)
		{
		tochka();
		tochka();
		tochka();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif4(void)
		{
		tochka();
		tochka();
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif5(void)
		{
		tochka();
		tochka();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif6(void)
		{
		tire();
		tochka();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif7(void)
		{
		tire();
		tire();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif8(void)
		{
		tire();
		tire();
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif9(void)
		{
		tire();
		tire();
		tire();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void space (void)
		{
		PORTB&=~(1<<cw);
		cw_delay(WORD_PAUSE);
		}
	void slash (void)
		{
		tire();
		tochka();
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}

func_type* func_adr[38]={bukvA,bukvB,bukvC,bukvD,bukvE,bukvF,bukvG,bukvH,bukvI,bukvG,bukvK,bukvL,bukvM,bukvN,bukvO,bukvP,bukvQ,bukvR,bukvS,bukvT,bukvU,bukvV,bukvW,bukvX,bukvY,bukvZ,cif0,cif1,cif2,cif3,cif4,cif5,cif6,cif7,cif8,cif9,space,slash};



	void cw_tx(unsigned char *ptr)
		{
		unsigned char i=0, i_func_adr;
		while(*(ptr+i))   //     - \0
			{
			if (*(ptr+i)==0) break;
			if (*(ptr+i)=='/') i_func_adr=37;  // 
			else
			{
			if (*(ptr+i)==' ') i_func_adr=36;  // 
				else
				{
				if (*(ptr+i)>=65) i_func_adr=*(ptr+i)-65;   // 
					else i_func_adr=*(ptr+i)-22;    //  
				}
			}
			p=func_adr[i_func_adr];
			(*p)(); //   
			i++;
			}
		}

	void u_measure(void)  //  
		{
		unsigned char i;
		double voltage=0;

		ADCSRA|=1<<ADEN|1<<ADIE;  // ,    
		sei();
		sleep_mode(); // 
		//  
		cli();
		ADCSRA&=~(1<<ADEN);
		ADCSRA&=~(1<<ADIE);
		voltage=R_division*2.56*adc*1.024; // 
//      
		if (voltage<U_POROG) flags.low_voltage=0;
			else flags.low_voltage=1;
		i=voltage/1000; 
		voltage=voltage-i*1000; 
		cw_str_vbatt[7]=0x30+i;  
		i=voltage/100; 
		voltage=voltage-i*100; 
		cw_str_vbatt[8]=0x30+i;
		i=voltage/10; 
		voltage=voltage-i*10; 
		cw_str_vbatt[9]=0x30+i;
		}


	void beeper (unsigned char i, unsigned short pause_)
		{
		while (i--)
			{
			cw_delay(pause_);
			cw_tx(letter_beep);
			}
		}

//     
	void ee_str_to_usart(unsigned char * ee_addr)
		{
		do
			{
			usart_tx(eeprom_read_byte(ee_addr));
			}
		while (eeprom_read_byte(++ee_addr));

		}



//   
 void usart_tx_str(unsigned char * usart_str)
 	{
	while (*(usart_str))
		{
		usart_tx (*(usart_str++));
		}
	}

//   
unsigned char read_byte_usart (void)
	{
		while( !(UCSRA&(1<<RXC)) ); // 
		return UDR;
	}

//    
	char txt_error (unsigned char * txt_string)
		{
		while (*(txt_string))
			{
			if ( ((*(txt_string)>=65)&(*(txt_string)<=90)) | ((*(txt_string)>=48)&(*(txt_string)<=57)) | (*(txt_string)==' ') | (*(txt_string)=='/') ) txt_string++;
				else return 0;
			}
			return 1;
		}

//    
	void set_bit_eeprom_byte(unsigned char * addr, unsigned char byte)
		{
		unsigned char buff;
		buff=eeprom_read_byte(addr);
		buff|=byte;
		eeprom_write_byte(addr, buff);
		}

//    
void clear_bit_eeprom_byte (unsigned char * addr, unsigned char byte)
	{
	unsigned char buff;
	buff=eeprom_read_byte(addr);
	buff&=~byte;
	eeprom_write_byte(addr, buff);
	}

//  
	void set_txt(void)
		{
		unsigned char i=0;
		unsigned char rx_buff[MAX_LENGTH_STR];
		
		usart_tx(CARRIAGE_RETURN); // 
		//    
		ee_str_to_usart(&ee_txt_hint);
//		usart_tx(CARRIAGE_RETURN); // 
		i=0;
		do
			{
			rx_buff[i]=read_byte_usart();
			usart_tx(rx_buff[i]);  //   
			}
		while ((rx_buff[i++]!=0)&(i<=MAX_LENGTH_STR));
		usart_tx(CARRIAGE_RETURN); // 

//   
		 if (txt_error(rx_buff)) 
		 	{
			//        
			usart_tx_str(cw_str_ok);
			_delay_ms(10);
			cw_tx(rx_buff);  //      
			}
		 	else 
				{
				//  error    
				usart_tx_str(cw_str_error);
				_delay_ms(10);
				cw_tx(cw_str_error);
				return;
				}
		//    
		do
			{
			eeprom_write_byte(&ee_cw_text[i],rx_buff[i]);
			}
		while (i--);
		set_bit_eeprom_byte(&ee_flags,(1<<USER_TXT));  //      
//		eeprom_write_byte(&ee_flags,(1<<USER_TXT));   //      
		}


//  
	void set_letter_beep(void)
		{
		//
		ee_str_to_usart(&ee_txt_hint_set_letter);
/*		do
			{
			usart_tx(eeprom_read_byte(&ee_txt_hint_set_letter[i]));
			}
		while (eeprom_read_byte(&ee_txt_hint_set_letter[++i]));
		i=0;*/
		letter_beep[0]=read_byte_usart();
		usart_tx(letter_beep[0]);
		if ((letter_beep[0]>='A')&(letter_beep[0]<='Z'))
			{
			usart_tx_str(cw_str_ok);
			eeprom_write_byte(&ee_letter_beep[0], letter_beep[0]);
			set_bit_eeprom_byte(&ee_flags,(1<<USER_LETTER_BEEP));  //      
//			eeprom_write_byte(&ee_flags,(1<<USER_LETTER_BEEP));   //      
			}
			else
				{
				usart_tx_str(cw_str_error);
				}
		}

//       	 
	void set_period_beep(void)
		{
		//
		ee_str_to_usart(&ee_txt_hint_period_beep);
/*		do
			{
			usart_tx(eeprom_read_byte(&ee_txt_hint_period_beep[i]));
			}
		while (eeprom_read_byte(&ee_txt_hint_period_beep[++i]));
		i=0;*/
		period_beep=read_byte_usart();
		usart_tx(period_beep);
		if ((period_beep>=MIN_POROG_PERIOD_DBEEP)&(period_beep<=MAX_POROG_PERIOD_DBEEP))
			{
			usart_tx_str(cw_str_ok);
			eeprom_write_byte(&ee_period_beep, period_beep);
			set_bit_eeprom_byte(&ee_flags,(1<<USER_PERIOD_BEEP));//     period_beep 
//			eeprom_write_byte(&ee_flags,(1<<USER_PERIOD_BEEP));   //     period_beep 
			}
			else
				{
				usart_tx_str(cw_str_error);
				}
		}

//    
	void set_beep_pause (void)
		{
		unsigned char beep_pause_buff;
		unsigned short beep_pause_buff_;
		//
		ee_str_to_usart(&ee_txt_hint_beep_pause);
		beep_pause_buff=read_byte_usart();
		usart_tx(beep_pause_buff);
		if ((beep_pause_buff>=MIN_POROG_BEEP_PAUSE)&(beep_pause_buff<=MAX_POROG_BEEP_PAUSE))
			{
			usart_tx_str(cw_str_ok);
			beep_pause_buff_=(unsigned short)beep_pause_buff*1000;
			eeprom_write_word(&ee_beep_pause,beep_pause_buff_);
			set_bit_eeprom_byte(&ee_flags,(1<<USER_BEEP_PAUSE));  //     beep_pause 
			}
			else
				{
				usart_tx_str(cw_str_error);
				}
		}

//  
	void set_beeper_on_off(void)
		{
		if (eeprom_read_byte(&ee_flags)&(1<<USER_BEEPER_ENABLE)) clear_bit_eeprom_byte(&ee_flags,(1<<USER_BEEPER_ENABLE));  // ;
				else set_bit_eeprom_byte(&ee_flags,(1<<USER_BEEPER_ENABLE));
		}

//   

	void set_voltage_on_off(void)
		{
		if (eeprom_read_byte(&ee_flags)&(1<<USER_VOLTMETER_ENABLE)) clear_bit_eeprom_byte(&ee_flags,(1<<USER_VOLTMETER_ENABLE));  // ;
			else set_bit_eeprom_byte(&ee_flags,(1<<USER_VOLTMETER_ENABLE));
		}
//   
	void set_temp_on_off(void)
		{
		if (eeprom_read_byte(&ee_flags)&(1<<USER_TEMP_ENABLE)) clear_bit_eeprom_byte(&ee_flags,(1<<USER_TEMP_ENABLE));  // ;
			else set_bit_eeprom_byte(&ee_flags,(1<<USER_TEMP_ENABLE));
		}

// 
	void set_param(void)
		{
		cw_tx(cw_str_settings);
		usart_tx(CARRIAGE_RETURN); // 
		//
		ee_str_to_usart(&ee_txt_url);
		usart_tx(CARRIAGE_RETURN); // 
		while (1) 
			{
			//    
			// 
			ee_str_to_usart(&ee_txt_temp);
			if (eeprom_read_byte(&ee_flags)&(1<<USER_TEMP_ENABLE)) ee_str_to_usart(&ee_txt_on);
				else 
				{
				ee_str_to_usart(&ee_txt_off);
				}
			usart_tx(CARRIAGE_RETURN); // 
			//
			ee_str_to_usart(&ee_txt_voltmeter);
			if (eeprom_read_byte(&ee_flags)&(1<<USER_VOLTMETER_ENABLE)) ee_str_to_usart(&ee_txt_on);
				else 
				{
				ee_str_to_usart(&ee_txt_off);
				}
			usart_tx(CARRIAGE_RETURN); // 
			//
			ee_str_to_usart(&ee_txt_beeper);
			if (eeprom_read_byte(&ee_flags)&(1<<USER_BEEPER_ENABLE)) ee_str_to_usart(&ee_txt_on);
				else 
				{
				ee_str_to_usart(&ee_txt_off);
				ee_str_to_usart(&ee_txt_set_pause_in_beep_pause);
				}
			usart_tx(CARRIAGE_RETURN); // 
			ee_str_to_usart(&ee_txt_hint_set);
			switch (read_byte_usart())
			{ 
				case 'T' : set_txt();break;
				case 'P' : set_period_beep();break;
				case 'B' : set_beep_pause();break;
				case 'L' : set_letter_beep();break;
				case 'M' : set_beeper_on_off();break;
				case 'V' : set_voltage_on_off();break;
				case 'C' : set_temp_on_off();break;
				case 'E' : return;
				default : break;
			}
		usart_tx(CARRIAGE_RETURN); // 
			}
		}

// --------------INTERRUPTS---------------------------------------------------------
	ISR(ADC_vect)
		{
		adc=(ADCL|ADCH<<8);  //    
		}

	ISR(TIMER2_OVF_vect)
		{
		TCNT2=130; //  
		SFIOR|=1<<PSR2;  //  
		}


	int main(void)
		{
		DDRC=0x00;  //    
		PORTC|=(1<<KNOB_SET_PARAM)|(1<<KNOB_ADC_PC0)|(1<<KNOB_TEMP_OFF)|(1<<KNOB_U_OFF);  //    PC2, PC3, PC4, PC5
		DDRB=0xFF;  //  
		PORTB=0x00;  //  
		usart_init(bauddivider);
		_delay_ms (10);
		// 
		if (PINC&(1<<KNOB_ADC_PC0)) ADMUX|=1<<REFS1|1<<REFS0|1<<MUX0|1<<MUX1|1<<MUX2;  //  ,   ADC7
			else
			{
				ADMUX|=1<<REFS1|1<<REFS0; //  ,   PC
			}
		ADCSRA|=1<<ADPS2|1<<ADPS0;  // 32, 125
		set_sleep_mode(SLEEP_MODE_ADC);  //    
		if (!(PINC&(1<<KNOB_SET_PARAM))) set_param();
		if (eeprom_read_byte(&ee_flags)&(1<<USER_TXT))
			{
			unsigned char i=0;
			do
				{
				cw_str[i]=eeprom_read_byte(&ee_cw_text[i]);
				}
			while(cw_str[i++]);
			}
		if (eeprom_read_byte(&ee_flags)&(1<<USER_PERIOD_BEEP)) period_beep=eeprom_read_byte(&ee_period_beep);
			else period_beep=PERIOD_BEEP_;
		if (eeprom_read_byte(&ee_flags)&(1<<USER_BEEP_PAUSE)) beep_pause=eeprom_read_word(&ee_beep_pause);
			else beep_pause=BEEP_PAUSE_;
		if (eeprom_read_byte(&ee_flags)&(1<<USER_LETTER_BEEP)) letter_beep[0]=eeprom_read_byte(&ee_letter_beep[0]);
			else letter_beep[0]=LETTER_BEEP_;
		if (eeprom_read_byte(&ee_flags)&(1<<USER_BEEPER_ENABLE)) flags.beeper_enable=1;
			else flags.beeper_enable=0;
		if (eeprom_read_byte(&ee_flags)&(1<<USER_VOLTMETER_ENABLE)) flags.voltmeter_enable=1;
			else flags.voltmeter_enable=0;
		if (eeprom_read_byte(&ee_flags)&(1<<USER_TEMP_ENABLE)) flags.temp_enable=1;
			else flags.temp_enable=0;
		PORTB|=1<<led;
		cw_delay(1000);
		PORTB&=~(1<<led);
		while (1)
			{	
				cw_tx(cw_str);  //  
				if ( PINC&(1<<KNOB_U_OFF))   //    
				{
					if ( flags.voltmeter_enable==1 )  //    
						{
							u_measure();  //   
							cw_tx(cw_str_vbatt);
						}
				}
				if (PINC&(1<<KNOB_TEMP_OFF))   //    
					{
					if ((flags.low_voltage==1)&(flags.temp_enable==1))
						{
						temp_measure(); //    DS18B20
						cw_tx(cw_str_temp);
						}
					}
				cw_tx(cw_str_end);
				if (flags.beeper_enable==1) beeper(period_beep, beep_pause);   //    .   S (  )  BEEP_PAUSE 
					else cw_delay(beep_pause);
			}

		}
